/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Twofish2.xs. Do not edit this file, edit Twofish2.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Twofish2.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* try to be compatible with older perls */
/* SvPV_nolen() macro first defined in 5.005_55 */
/* this is slow, not threadsafe, but works */
#include "patchlevel.h"
#if (PATCHLEVEL == 4) || ((PATCHLEVEL == 5) && (SUBVERSION < 55))
static STRLEN nolen_na;
# define SvPV_nolen(sv) SvPV ((sv), nolen_na)
#endif

#include "aes.h"
#include "twofish.c"

typedef struct cryptstate {
  keyInstance ki;
  cipherInstance ci;
} *Crypt__Twofish2;

#line 32 "Twofish2.c"

XS(XS_Crypt__Twofish2_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Twofish2_new)
{
    dXSARGS;
    if (items < 2 || items > 3)
	Perl_croak(aTHX_ "Usage: Crypt::Twofish2::new(class, key, mode=MODE_ECB)");
    {
	SV *	class = ST(0);
	SV *	key = ST(1);
	int	mode;
	Crypt__Twofish2	RETVAL;

	if (items < 3)
	    mode = MODE_ECB;
	else {
	    mode = (int)SvIV(ST(2));
	}
#line 43 "Twofish2.xs"
        {
          STRLEN keysize;

          if (!SvPOK (key))
            croak ("key must be a string scalar");

          keysize = SvCUR(key);

          if (keysize != 16 && keysize != 24 && keysize != 32)
            croak ("wrong key length: key must be 128, 192 or 256 bits long");
          if (mode != MODE_ECB && mode != MODE_CBC && mode != MODE_CFB1)
            croak ("illegal mode: mode must be MODE_ECB, MODE_2 or MODE_CFB1");

          Newz(0, RETVAL, 1, struct cryptstate);

          if (makeKey (&RETVAL->ki, DIR_ENCRYPT, keysize*8, SvPV_nolen(key)) != TRUE)
            croak ("Crypt::Twofish2: makeKey failed, please report!");
          if (cipherInit (&RETVAL->ci, mode, 0) != TRUE) /* no IV supported (yet) */
            croak ("Crypt::Twofish2: makeKey failed, please report!");
        }         
#line 72 "Twofish2.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::Twofish2", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__Twofish2_encrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Twofish2_encrypt)
{
    dXSARGS;
    dXSI32;
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(self, data)", GvNAME(CvGV(cv)));
    {
	Crypt__Twofish2	self;
	SV *	data = ST(1);
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::Twofish2")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Twofish2,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::Twofish2");
#line 73 "Twofish2.xs"
        {
          SV *res;
          STRLEN size;
          void *rawbytes = SvPV(data,size);

          if (size)
            {
              if (size % (BLOCK_SIZE >> 3))
                croak ("encrypt: datasize not multiple of blocksize (%d bits)", BLOCK_SIZE);

              RETVAL = NEWSV (0, size);
              SvPOK_only (RETVAL);
              (SvPVX (RETVAL))[size] = 0;
              SvCUR_set (RETVAL, size);

              if ((ix ? blockDecrypt : blockEncrypt)
                    (&self->ci, &self->ki, rawbytes, size << 3, (void *)SvPV_nolen(RETVAL)) < 0)
                croak ("block(De|En)crypt: unknown error, please report");
            }
          else
            RETVAL = newSVpv ("", 0);
        }
#line 121 "Twofish2.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__Twofish2_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__Twofish2_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::Twofish2::DESTROY(self)");
    {
	Crypt__Twofish2	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__Twofish2,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not a reference");
#line 102 "Twofish2.xs"
        Safefree(self);
#line 146 "Twofish2.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__Twofish2); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__Twofish2)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXSproto("Crypt::Twofish2::new", XS_Crypt__Twofish2_new, file, "$$;$");
        cv = newXS("Crypt::Twofish2::decrypt", XS_Crypt__Twofish2_encrypt, file);
        XSANY.any_i32 = 1 ;
        sv_setpv((SV*)cv, "$$") ;
        cv = newXS("Crypt::Twofish2::encrypt", XS_Crypt__Twofish2_encrypt, file);
        XSANY.any_i32 = 0 ;
        sv_setpv((SV*)cv, "$$") ;
        newXSproto("Crypt::Twofish2::DESTROY", XS_Crypt__Twofish2_DESTROY, file, "$");
    }

    /* Initialisation Section */

#line 27 "Twofish2.xs"
{
	HV *stash = gv_stashpv ("Crypt::Twofish2", 0);

	newCONSTSUB (stash, "keysize",   newSViv (32));
	newCONSTSUB (stash, "blocksize", newSViv (16));
	newCONSTSUB (stash, "MODE_ECB",  newSViv (MODE_ECB));
	newCONSTSUB (stash, "MODE_CBC",  newSViv (MODE_CBC));
	newCONSTSUB (stash, "MODE_CFB1", newSViv (MODE_CFB1));
}

#line 188 "Twofish2.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

